// cMatrix.hpp

class cMatrix;

#import "math3d.h"
#import "cVector.hpp"
#import "cPlane.hpp"

class cMatrix {
  public:
  MATRIX            mM;
  public:
                    cMatrix();
  void              Set();
  void              Set(SCALAR a1, SCALAR a2, SCALAR a3, SCALAR a4,
                        SCALAR b1, SCALAR b2, SCALAR b3, SCALAR b4,
                        SCALAR c1, SCALAR c2, SCALAR c3, SCALAR c4,
                        SCALAR d1, SCALAR d2, SCALAR d3, SCALAR d4);
  void              Inv();
  void              MovRel(SCALAR x, SCALAR y, SCALAR z);
  void              Mul(cMatrix m);
  void              Add(cMatrix m);
  void              Scale(SCALAR sx, SCALAR sy, SCALAR sz);
  void              RotXYZ(ANGLE a, ANGLE b, ANGLE c);
  void              RotX(ANGLE a);
  void              RotY(ANGLE a);
  void              RotZ(ANGLE a);
  void              Apply(cVector &v);
  void              Apply(cVector &vOut, cVector &v);
  void              MakeProjection(cPlane plane, cVector center);
  void              MakeCameraRot(cVector pnt, cVector rot);
  void              MakeCameraPos(cVector pnt, cVector pos);
  void              MakeObjectRot(cVector pnt, cVector rot);
  void              MakeObjectPos(cVector pnt, cVector pos);
};


